import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'admin' },
})
export class Admin extends BaseModel {
  @prop({ required: true, index: false, zh: '管理员名称' })
  nick_name: string;
  @prop({ required: true, index: false, zh: '账号' })
  account: string;
  // 手动删除set前的大括号,处理太麻烦了.就手动删除吧
  @prop({
    required: true,
    index: false,
    zh: '密码',
    select: false,
    set: val => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: object;
  @prop({ required: false, index: false, zh: '拥有角色', remark: '可以有多个角色扩展权限' })
  role: Array<any>;
  @prop({ required: false, index: false, zh: '所属部门', remark: '只能隶属1各部门' })
  dept: string;
  @prop({ required: false, index: false, zh: '是否是超级管理员', remark: '0:是;1否', default: '1' })
  is_super: string;
  @prop({ required: false, index: false, zh: '使用状态', remark: '0:正常;1冻结', default: '0' })
  is_use: string;
}
