import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'user' },
})
export class User extends BaseModel {
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  // 手动删除set前的大括号,处理太麻烦了.就手动删除吧
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: val => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: object;
  @prop({ required: false, index: false, zh: '昵称' })
  nick_name: string;
  @prop({ required: false, index: false, zh: '性别' })
  gender: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '角色' })
  role: Array<any>;
  @prop({ required: false, index: true, zh: '状态', default: '1' })
  status: string;
}
