import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dataLogs {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '表' })
  'collection': string = undefined;
  @ApiProperty({ description: '数据id' })
  'id': string = undefined;
  @ApiProperty({ description: '时间' })
  'time': string = undefined;
  @ApiProperty({ description: '数据库操作方法' })
  'method': string = undefined;
  @ApiProperty({ description: '数据' })
  'data': object = undefined;
}

export class QDTO_dataLogs extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['collection'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '表' })
  'collection': string = undefined;
}

export class QVO_dataLogs extends FVO_dataLogs {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dataLogs {
  @ApiProperty({ description: '表' })
  @Rule(RuleType['string']().empty(''))
  'collection': string = undefined;
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  'id': string = undefined;
  @ApiProperty({ description: '时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '数据库操作方法' })
  @Rule(RuleType['string']().empty(''))
  'method': string = undefined;
  @ApiProperty({ description: '数据' })
  @Rule(RuleType['object']().empty(''))
  'data': object = undefined;
}

export class CVO_dataLogs extends FVO_dataLogs {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dataLogs extends CDTO_dataLogs {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dataLogs extends FVO_dataLogs {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
