import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dept {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '部门名称' })
  'name': string = undefined;
  @ApiProperty({ description: '资源权限' })
  'resource': Array<any> = undefined;
  @ApiProperty({ description: '上级部门id' })
  'parent_id': string = undefined;
  @ApiProperty({ description: '使用状态' })
  'is_use': string = undefined;
  @ApiProperty({ description: '是否是总部门' })
  'is_super': string = undefined;
  @ApiProperty({ description: '排序' })
  'order_num': number = undefined;
}


export class QDTO_dept extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}


export class QVO_dept extends FVO_dept {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class CDTO_dept {
  @ApiProperty({ description: '部门名称' })
@Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '资源权限' })
@Rule(RuleType['array']().empty(''))
  'resource': Array<any> = undefined;
  @ApiProperty({ description: '上级部门id' })
@Rule(RuleType['string']().empty(''))
  'parent_id': string = undefined;
  @ApiProperty({ description: '使用状态' })
@Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
  @ApiProperty({ description: '是否是总部门' })
@Rule(RuleType['string']().empty(''))
  'is_super': string = undefined;
  @ApiProperty({ description: '排序' })
@Rule(RuleType['number']().empty(''))
  'order_num': number = undefined;
}


export class CVO_dept extends FVO_dept {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class UDTO_dept extends CDTO_dept {
    @ApiProperty({ description: '数据id' })
    @Rule(RuleType['string']().empty(''))
    _id: string = undefined;
}


export class UVAO_dept extends FVO_dept {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}